/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package generatetestruns;

import java.rmi.RemoteException;
import java.util.logging.Level;
import java.util.logging.Logger;
import testtrack_Interface.*;
//import java.net.URL;
import javax.xml.rpc.Stub;

/**
 *
 * @author cremerf
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
           //Before we do anything, let's make sure we have the nescessary arguments
        if (args.length == 3)
        {
            //Define our logging object
            Logger logger = Logger.getLogger("error.text");

            //Define variables for app
            //TestTrack SOAP connection vars - config file
            String ttServer = "";
            String ttUser = "";
            String ttPassword = "";

            //Variables used for generating runs - passed as parameters
            String ttProject = "";
            String ttRunSet = "";
            String ttFilter = "";

            //other variables for processing
            long ttCookie;
            long tcNumber = 0;

            //Read vars from config file
            Config config = new Config();

            ttServer = config.GetTTServer();
            ttUser = config.GetTTUser();
            ttPassword = config.GetTTPassword();

            ttProject = args[0];
            ttFilter = args[1];
            ttRunSet = args[2];

            
            try
            {
                //Define soap cgi object
                TtsoapcgiPortType_Stub ttSoap = (TtsoapcgiPortType_Stub)(new Ttsoapcgi_Impl().getTtsoapcgi());
                //Set the soap cgi URL
                ttSoap._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, ttServer);

                CDatabase ttDatabase = new CDatabase();
                ttDatabase.setName(ttProject);
                CProjectDataOption[] projOps = new CProjectDataOption[1];
                projOps[0] = new CProjectDataOption();
                projOps[0].setName("TestTrack TCM");
                CProject ttCProject = new CProject();
                ttCProject.setDatabase(ttDatabase);
                ttCProject.setOptions(projOps);

                if (ttCProject != null)
                {
                    try
                    {

                        //if we found project for user, lets log in
                        ttCookie = ttSoap.projectLogon(ttCProject,ttUser,ttPassword);

                        //Check to see if Test Run Set exists

                        boolean ttFlag = false;

                        CFieldValue[] ttFValues = ttSoap.getDropdownFieldValuesForTable(ttCookie, "Test Run", "Test Run Set");
                        for (int i = 0; i < ttFValues.length; i++)
                        {
                            if (ttFValues[i].getValue().equals(ttRunSet))
                            {
                                ttFlag = true;
                            }
                        }
                        if (ttFlag == false)
                        {
                            CFieldValue[] newValues = null;
                            int length = ttFValues.length;
                            if (length > 0)
                            {
                                length = length + 1;
                                newValues = new CFieldValue[length];
                                for (int i = 0; i < length; i++)
                                {
                                //Last value will be the new value
                                    if (i == length - 1)
                                    {
                                        newValues[i] = new CFieldValue();
                                        newValues[i].setValue(ttRunSet);
                                    }
                                    else
                                    {
                                        newValues[i] = new CFieldValue();
                                        newValues[i].setValue(ttFValues[i].getValue());
                                    }
                                }


                            }
                            else
                            {
                                newValues = new CFieldValue[1];
                                newValues[0] = new CFieldValue();
                                newValues[0].setValue(ttRunSet);

                            }
                            ttSoap.addDropdownFieldValuesForTable(ttCookie, "Test Run", "Test Run Set", newValues);
                        }
                        //Now we get the list of test cases that passes the filter
                        CTableColumn[] ttColumns = new CTableColumn[1];
                        //We need to instantiate each column (you'll get a null exception if you don't)
                        ttColumns[0] = new CTableColumn();
                        //After you instantiate the column, then give it the name
                        ttColumns[0].setName("Number");

                       //Define our variable that will hold the defects
                       //I am defining it here because I will use it outside of the
                        //embedded try catch below
                        CRecordListSoap ttRecords = new CRecordListSoap();

                        try
                        {
                           ttRecords = ttSoap.getRecordListForTable(ttCookie, "Test Case", ttFilter,ttColumns  );
                        }
                        catch (Exception fcc)
                        {
                            java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, fcc);
                        }
                        //Get the rows from the defect list
                        CRecordRowSoap[] testCaseRows = ttRecords.getRecords();
                        //For each row, generate test runs
                        for (int i = 0; i < testCaseRows.length;i++)
                        {
                            String tcNum = testCaseRows[i].getRow()[0].getValue();
                            tcNumber = Integer.parseInt(tcNum);
                            //Get test case object
                            CTestCase ttTCase = ttSoap.getTestCase(ttCookie, tcNumber, "", false);
                            //before we can generate the test run for the test case, we need
                            //to build our test runs.  We'll use all variants defined in the test case
                            CTestRunVariantField[] ttRunVariants = new CTestRunVariantField[ttTCase.getTestVariants().length];
                            for (int k = 0; k < ttTCase.getTestVariants().length; k++)
                            {
                                //Need to make sure we only look at the "Included" variants, and not the "Excluded" ones.
                                if (ttTCase.getTestVariants()[k].getType().equals("Included"))
                                {
                                    CFieldValue[] tvVal = new CFieldValue[ttTCase.getTestVariants()[k].getValues().length];
                                    //Go through each value in this variant
                                    for (int l = 0; l < ttTCase.getTestVariants()[k].getValues().length; l++)
                                    {
                                        tvVal[l] = new CFieldValue();
                                        tvVal[l].setValue(ttTCase.getTestVariants()[k].getValues()[l].getValue());
                                    }
                                    ttRunVariants[k] = new CTestRunVariantField();
                                    ttRunVariants[k].setName(ttTCase.getTestVariants()[k].getName());
                                    ttRunVariants[k].setValues(tvVal);
                                }
                            }
                            //Now we can generate the test run

                            CItemToTrack[] ttRuns = ttSoap.generateTestRuns(ttCookie, ttTCase.getRecordid(), ttRunVariants, ttRunSet);

                        }
                        ttSoap.databaseLogoff(ttCookie);
                    }

                    catch(Exception fcc)
                    {
                        logger.fine(fcc.getMessage());
                    }
                   
                }
            }
            catch (Exception fcc)
            {

                System.out.println(fcc.getLocalizedMessage());
                System.out.println(fcc.getMessage());
                logger.fine(fcc.getMessage());
            }



        }
    }

    

}
